import { StateField, Extension, StateEffectType, Facet } from '@codemirror/state';
import { PluginValue, EditorView, ViewPlugin } from '@codemirror/view';
import { Diagnostic as CodeMirrorDiagnostic } from '@codemirror/lint';
import { Diagnostic as LSPDiagnostic } from 'vscode-languageserver-protocol';
declare class DiagnosticsPlugin implements PluginValue {
    private handlers;
    constructor(view: EditorView);
    destroy(): void;
}
export declare const setLSPDiagnosticsVersion: StateEffectType<number | null>;
export declare const lspDiagnosticsVersionField: StateField<number | null>;
export declare const setLSPDiagnostics: StateEffectType<LSPDiagnostic[]>;
export declare const lspDiagnosticsField: StateField<LSPDiagnostic[]>;
export declare const diagnosticsFacet: Facet<CodeMirrorDiagnostic[], CodeMirrorDiagnostic[]>;
export declare const computedCodeMirrorDiagnosticsValueProvider: Extension;
export declare const diagnosticsLinter: Extension;
export declare const diagnosticsPlugin: ViewPlugin<DiagnosticsPlugin>;
export declare const lspLinter: Extension;
export {};
